/* 
 * File:     World.cpp
 * Author:   NMM
 * Date:     12.03.2006
 * Modified: 27.03.2006
 *
 * Purpose: Definitionen der Klasse World
 */
 
#include "World.h"

#define STARTING_SHEEP 100 


//Funktionen der Klasse Simulation

World::World(){
  int i;
  PaeSheep *this_sheep;
    
  /*
   * Construct the terrain
   */
  terr = new PaeTerrain();                       
  terr->ScaleTerrain(-5.0, 5.0);
  terr->ReBuildNormals();


  /* 
   * Add sheep to the sheep list
   */
   
  firstsheep = NULL;
  CreateSheep(100);

  /*
   * One experimental Stone
   */
  stone = new Stone();
  stone->SetPosition(20.0,30.0,2.0);

  cout << "World created!" << endl;

}


void World::CreateSheep(){

  CreateSheep(1);

}

void World::CreateSheep(int n){

    PaeSheep *new_sheep;
    PaeSheep *last_sheep;
    float x;
    float y;

	/*
	 * Keine Schafe => Bye-bye
	 */

	if(n <= 0 ){
	  return;
	}


	/*
	 * We look for the last sheep in the list
	 */
	last_sheep = NULL;
    new_sheep = firstsheep;
    while(new_sheep != NULL){
      last_sheep = new_sheep;
	  new_sheep = new_sheep->nextsheep;
    }


	/*
	 * last_sheep is now NULL or pointing to the last sheep
	 */
	if(last_sheep == NULL){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  firstsheep = new PaeSheep(x,y,this);
	  last_sheep = firstsheep;
	  n--;
	}


	/*
	 * last_sheep is pointing to the last sheep
	 */

	for(int i=0;i<n;i++){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  last_sheep->nextsheep = new PaeSheep(x,y,this);
	  last_sheep = last_sheep->nextsheep;
	}
}





void World::Draw(){
  PaeSheep *this_sheep;
  int i;
  i=0;
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    terr->Draw();
  glPopMatrix();

  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    stone->Draw();
  glPopMatrix();

  this_sheep = firstsheep;
  while(this_sheep != NULL){       //sage jedem Schaf, dass es sich zeichnen soll
    i++;
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
      this_sheep->Draw();
    glPopMatrix();
    this_sheep = this_sheep->nextsheep;
	
  }

}









void World::Prepare(){
     PaeSheep *this_sheep;
     this_sheep = firstsheep;
     while(this_sheep != NULL){
       this_sheep->Think();
       this_sheep = this_sheep->nextsheep;
     }         
}

void World::Action(){
  float cur_pos[3];
  int invert_flag;
  PaeSheep *this_sheep;

  terr->GrowFood();

  this_sheep = firstsheep;
  while(this_sheep != NULL){
    this_sheep->Move();
	
	/*
	 * If sheep leaves terrain, turn it around!
	 */
	invert_flag = false;
	this_sheep->GetPosition(cur_pos);
	if (cur_pos[0] < 0.0){
	  cur_pos[0] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[0] >= 99.0){
	  cur_pos[0] = 98.9;
	  invert_flag = true;
	}
	if (cur_pos[1] < 0.0){
	  cur_pos[1] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[1] >= 99.0){
	  cur_pos[1] = 98.9;
	  invert_flag = true;
	}
	if(invert_flag){
	  this_sheep->InvertDirection();
	}

	/*
	 * Put sheep to the right height
	 */
	cur_pos[2] = terr->GetHeight(cur_pos[0],cur_pos[1]);
	this_sheep->SetPosition(cur_pos[0],cur_pos[1],cur_pos[2]);
	
	/*
	 * next, please!
	 */
    this_sheep = this_sheep->nextsheep;
  }         
}

float World::GetHeight(float x, float y){
      return 1; // terr->GetHeight(x,y);
}

   
